/*
 *  Copyright (C) 2006 Tony Sin(x) '76 <tony@becrux.com>
 *  All rights reserved.
 *
 */

/*
 *                  GNU GENERAL PUBLIC LICENSE
 *                    Version 2, June 1991
 *
 *  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
 *                           675 Mass Ave, Cambridge, MA 02139, USA
 *  Everyone is permitted to copy and distribute verbatim copies
 *  of this license document, but changing it is not allowed.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __message_h__
#define __message_h__

#ifdef HAVE_CONFIG_H
  #ifndef __main_config_h__
    #define __main_config_h__
    #include "../config.h"
  #endif
#endif

#define MESSAGE_CLASS_NAME    "cMessage"
#define MESSAGE_CLASS_NAME_D  "~cMessage"
#define UNKNOWN_SENDER        "UNKNOWN"
#define MAX_RECIPIENTS        100
#define LOC_DATE_SIZE         64

enum lineType { _fixed = 0, _sender = 1, _host = 2, _date = 3, _virname = 4, _error = 5 };
enum stateType { _reset = 0, _startTag = 1, _insideTag = 2, _outsideTag = 3 };

struct msgLineType
{
  lineType type;
  char *data;
  struct msgLineType *next;
};

class cMessage
{
  static struct msgLineType *msgLines;
  static bool message_en;
  static int counter;
  static char *sender;
  static char *subject;
  char *bg_sender;
  char *date;
  char *host;
  char *recipients[MAX_RECIPIENTS];
  int recipients_num;

public:
  cMessage(const char *fileName = NULL);
  ~cMessage();
  void loadMessage(const char *fileName);
  void loadControlFile(const char *fileName);
  void sendMessage(const char *virName);
};

#endif
